#!/usr/bin/env python

from binascii import hexlify
from struct import unpack_from
import os

f = open("/dev/input/event3", "r")
x = y = z = 0
text = "\t%8d\t%8d\t%8d" % ( x, y, z )
maxx = maxy = maxz = 0
minx = miny = minz = 0 

oldmode = newmode = "unknown"

while True:
    block = f.read(16)
    if block[8] == "\x02":
        if block[10] == "\x00":
           x = unpack_from( "@l", block[12:] )[0]
           maxx, minx = max( x, maxx ), min( x, minx )
           continue
        if block[10] == "\x01":
           y = unpack_from( "@l", block[12:] )[0]
           maxy, miny = max( y, maxy ), min( y, miny )
           continue
        if block[10] == "\x02":
           z = unpack_from( "@l", block[12:] )[0]
           maxz, minz = max( z, maxz ), min( z, minz )
           text = "\t%8d\t%8d\t%8d" % ( x, y, z )

    if abs(x) < 600 and abs(y) > 600:
        newmode = "portrait"
    if abs(x) > 600 and abs(y) < 600:
        newmode = "landscape"

    output = "%s\t[%s]\r" % ( text, oldmode )
    print output,

    if newmode != oldmode:
        if newmode == "landscape":
           if x < 0: os.system( "xrandr -o 3" )
           elif x > 0: os.system( "xrandr -o 1" )
        if newmode == "portrait": os.system( "xrandr -o 0" )
        oldmode = newmode


